=== test/Makefile ===
include ../config.make

NO_COLOR=\033[0m
OK_COLOR=\033[32;01m
ERROR_COLOR=\033[31;01m
SKIP_COLOR=\033[0;34m
padlimit=60
padlength=60

ZFP_LIBS = -lzfp
ifeq ($(ZFP_HAS_CFP),1)
    ZFP_LIBS += -lcfp -lstdc++
endif

.PHONY: lib plugin check patch clean

patch:
	@echo "If using HDF5-1.8, make sure you have patched repack"

plugin:
	cd ../src; $(MAKE) $(MAKEVARS) $@

lib:
	cd ../src; $(MAKE) $(MAKEVARS) $@

test_write_plugin.o: test_write.c
	$(CC) -c $< -o $@ -DH5Z_ZFP_USE_PLUGIN -DZFP_LIB_VERSION=0x$(ZFP_LIB_VERSION) $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

test_write_lib.o: test_write.c
	$(CC) -c $< -o $@ $(CFLAGS) -DZFP_HAS_CFP=$(ZFP_HAS_CFP) -DZFP_LIB_VERSION=0x$(ZFP_LIB_VERSION) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

test_write_plugin: test_write_plugin.o plugin
	$(CC) $< -o $@ $(CFLAGS) $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L$(HDF5_LIB) -L$(ZFP_LIB) -lhdf5 $(ZFP_LIBS) -lm $(LDFLAGS)

test_write_lib: test_write_lib.o lib
	$(CC) $< -o $@ $(CFLAGS) $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L../src -L$(HDF5_LIB) -L$(ZFP_LIB) -lh5zzfp -lhdf5 $(ZFP_LIBS) -lm $(LDFLAGS)

test_read_plugin.o: test_read.c
	$(CC) -c $< -o $@ -DH5Z_ZFP_USE_PLUGIN $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

test_read_lib.o: test_read.c
	$(CC) -c $< -o $@ $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

test_read_plugin: test_read_plugin.o plugin
	$(CC) $< -o $@ $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L$(HDF5_LIB) -L$(ZFP_LIB) -lhdf5 $(ZFP_LIBS) $(LDFLAGS)

test_read_lib: test_read_lib.o lib
	$(CC) $< -o $@ $(CFLAGS) $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L../src -L$(HDF5_LIB) -L$(ZFP_LIB) -lh5zzfp -lhdf5 $(ZFP_LIBS) $(LDFLAGS)

test_error.o: test_error.c
	$(CC) -c $< -o $@ $(CFLAGS) -DZFP_LIB_VERSION=0x$(ZFP_LIB_VERSION) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

test_error: test_error.o lib
	$(CC) $< -o $@ $(CFLAGS) $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L../src -L$(HDF5_LIB) -L$(ZFP_LIB) -lh5zzfp -lhdf5 $(ZFP_LIBS) -lm $(LDFLAGS)

print_h5repack_farg: print_h5repack_farg.o
	$(CC) $< -o $@ $(LDFLAGS)

print_h5repack_farg.o: print_h5repack_farg.c
	$(CC) -c $< -o $@ $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(HDF5_INC)

ifneq ($(FC),) # Fortran Tests [

test_rw_fortran: test_rw_fortran.o lib
	$(FC) $(FCFLAGS) -o $@ $< $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L../src -L$(HDF5_LIB) -L$(ZFP_LIB) -lh5zzfp -lhdf5_fortran -lhdf5 $(ZFP_LIBS) $(LDFLAGS)

%.o:%.F90
	$(FC)  -o $@ -c $< $(FCFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)


# Note: The write-half of all the Fortran tests utilize the default and properties
# interface library to control the filter. The read-half uses the plugin.

test-default : test_rw_fortran
	 @echo " "; \
	 pad=$$(printf '%*s' "$(padlimit)"); \
	 pad=$${pad// /.}; \
         x="./test_rw_fortran"; \
	 printf "$$x"; \
	 printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
         $$x 2>&1 1>/dev/null; \
         if [[ $$status -ne 0 ]]; then \
	     printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	     touch check-failed; \
	     exit 0; \
          fi; \
	  printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \

# Decrease bit rate and confirm compression ratio increases
test-rate-f: plugin test_rw_fortran
	 @echo " "; \
	 pad=$$(printf '%*s' "$(padlimit)"); \
	 pad=$${pad// /.}; \
	 for r in 32 16 8 4; do\
            x="./test_rw_fortran zfpmode 1 rate $$r"; \
            printf "$$x"; \
	    printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	    expected_ratio=$$(expr 64 \/ $$r); \
	    $$x >/dev/null 2>/dev/null; \
            status=$$?; \
            if [[ $$status -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
            fi; \
	    actual_ratio=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5dump -H -d compressed -p test_zfp_fortran.h5 | grep COMPRESSION | cut -d':' -f1 | cut -d'(' -f2 | cut -d'.' -f1); \
	    if [[ $$expected_ratio -ne $$actual_ratio ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DUMP*$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
	    fi; \
	    actual_ratio=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5dump -H -d compressed-plugin -p test_zfp_fortran.h5 | grep COMPRESSION | cut -d':' -f1 | cut -d'(' -f2 | cut -d'.' -f1); \
	    if [[ $$expected_ratio -ne $$actual_ratio ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DUMP*$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
	    fi; \
	    printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \
	done; \

# Increase accuracy and test absolute error tolerance is within accuracy
test-accuracy-f: plugin test_rw_fortran
	 @echo " "; \
	 pad=$$(printf '%*s' "$(padlimit)"); \
	 pad=$${pad// /.}; \
	 for a in 0.1 0.01 0.001 0.0001; do\
            x="./test_rw_fortran zfpmode 3 acc $$a write"; \
            printf "$$x"; \
	    printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	    $$x >/dev/null 2>/dev/null; \
            status=$$?; \
            if [[ $$status -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
            fi; \
	    env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -d $$a test_zfp_fortran.h5 test_zfp_fortran.h5 compressed original 2>&1 1>/dev/null; \
	    if [[ $$? -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
	    fi; \
	    env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -d $$a test_zfp_fortran.h5 test_zfp_fortran.h5 compressed-plugin original 2>&1 1>/dev/null; \
	    if [[ $$? -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
	    fi; \
	    printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \
	done; \

# Increase precision and confirm diff count for given tolerance drops
test-precision-f: plugin test_rw_fortran
	 @echo " "; \
	 pad=$$(printf '%*s' "$(padlimit)"); \
	 pad=$${pad// /.}; \
	 for p in 12 16 20 24; do\
            x="./test_rw_fortran zfpmode 2 prec $$p write"; \
            printf "$$x"; \
	    printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	    $$x >/dev/null 2>/dev/null; \
            status=$$?; \
            if [[ $$status -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
            fi; \
	    diffcnt=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -p 0.00001 test_zfp_fortran.h5 test_zfp_fortran.h5 compressed original | grep 'differences found' | cut -d' ' -f1); \
	    if [[ $$ldiffcnt -ne 0 ]] && [[ $$diffcnt -gt $$ldiffcnt ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	        touch check-failed; \
		exit 0; \
	    fi; \
	    diffcnt=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -p 0.00001 test_zfp_fortran.h5 test_zfp_fortran.h5 compressed-plugin original | grep 'differences found' | cut -d' ' -f1); \
	    if [[ $$ldiffcnt -ne 0 ]] && [[ $$diffcnt -gt $$ldiffcnt ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	        touch check-failed; \
		exit 0; \
	    fi; \
	    printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \
	 done; \

# Ensure reversible gives bit-for-bit identical results
test-reversible-f: plugin test_rw_fortran
	@echo " "; \
	pad=$$(printf '%*s' "$(padlimit)"); \
	pad=$${pad// /.}; \
	x="./test_rw_fortran zfpmode 5 write"; \
        printf "$$x"; \
	printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	$$x >/dev/null 2>/dev/null; \
        status=$$?; \
        if [[ $$status -ne 0 ]]; then \
	    printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	    touch check-failed; \
            exit 0; \
         fi; \
	diffcnt=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -p 0.00001 test_zfp_fortran.h5 test_zfp_fortran.h5 compressed original | grep 'differences found' | cut -d' ' -f1); \
	if [[ $$diffcnt -ne 0 ]]; then \
	    printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	    touch check-failed; \
	    exit 0; \
	fi; \
	diffcnt=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -p 0.00001 test_zfp_fortran.h5 test_zfp_fortran.h5 compressed-plugin original | grep 'differences found' | cut -d' ' -f1); \
	if [[ $$diffcnt -ne 0 ]]; then \
	    printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	    touch check-failed; \
	    exit 0; \
	fi; \
	printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n\n"; \

endif # ] ifneq ($(FC),)

# Decrease bit rate and confirm compression ratio increases
test-rate: plugin test_write_plugin
	@failed=0; \
	echo " "; \
	pad=$$(printf '%*s' "$(padlimit)"); \
	pad=$${pad// /.}; \
	for r in 32 16 8 4; do \
	    expected_ratio=$$(expr 64 \/ $$r); \
	    x="./test_write_plugin zfpmode=1 rate=$$r"; \
            printf "$$x"; \
	    printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	    env HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $$x 2>&1 1>/dev/null; \
            if [[ $$? -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        failed=1; \
	        touch check-failed; \
	        continue; \
            fi; \
	    actual_ratio=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5dump -H -d compressed -p test_zfp.h5 | grep COMPRESSION | cut -d':' -f1 | cut -d'(' -f2 | cut -d'.' -f1); \
	    if [[ $$expected_ratio -ne $$actual_ratio ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        failed=1; \
	        touch check-failed; \
	        continue; \
	    fi; \
	    printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \
	done; \
	x="Plugin rate tests"; \
        printf "$$x"; \
	printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
        if [[ $$failed -ne 0 ]]; then \
	    printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	    exit 0; \
	fi; \
	printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"

# Increase accuracy and test absolute error tolerance is within accuracy
test-accuracy: plugin test_write_plugin
	@failed=0; \
	echo " "; \
	pad=$$(printf '%*s' "$(padlimit)"); \
	pad=$${pad// /.}; \
	for a in 0.1 0.01 0.001 0.0001; do\
	    x="./test_write_plugin zfpmode=3 acc=$$a"; \
            printf "$$x"; \
	    printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	    env HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $$x 2>&1 1>/dev/null; \
            if [[ $$? -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        failed=1; \
	        touch check-failed; \
	        continue; \
	    fi; \
	    env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -d $$a test_zfp.h5 test_zfp.h5 compressed original 2>&1 1>/dev/null; \
	    if [[ $$? -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        echo "Plugin accuracy test failed for accuracy=$$a"; \
	        failed=1; \
	        touch check-failed; \
	        continue; \
	    fi; \
	    printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \
	done; \
	x="Plugin accuracy tests"; \
        printf "$$x"; \
	printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
        if [[ $$failed -ne 0 ]]; then \
	    printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	    exit 0; \
	fi; \
	printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"

# Increase precision and confirm diff count for given tolerance drops
test-precision: plugin test_write_plugin
	@failed=0; \
	echo " "; \
	pad=$$(printf '%*s' "$(padlimit)"); \
	pad=$${pad// /.}; \
	ldiffcnt=0; \
	for p in 12 16 20 24; do\
