=== debian/changelog ===
h5z-zfp (1.1.0+git20221021-4) unstable; urgency=medium

  * Added Provides/Conflict/Replaces for the old name hdf5-plugin-zfp.
    Closes: #1030029
  * Use the new B-D architecture-is-little-endian instead of a long arch list

 -- Enrico Zini <enrico@debian.org>  Tue, 31 Jan 2023 16:36:21 +0100

h5z-zfp (1.1.0+git20221021-3) unstable; urgency=medium

  * Set Maintainer to debian-science-maintainers@lists.alioth.debian.org
    and uploaders to team+freexian@tracker.debian.org
  * Renamed binary package to hdf5-filter-plugin-zfp-serial to follow
    https://salsa.debian.org/science-team/h5f-packaging-guidelines
  * Added simple autopkgtest
  * Do not try to build on big-endian machines, due to
    https://github.com/LLNL/H5Z-ZFP/issues/95

 -- Enrico Zini <enrico@debian.org>  Sun, 29 Jan 2023 12:01:37 +0100

h5z-zfp (1.1.0+git20221021-2) unstable; urgency=medium

  * Marked documentation-only Build-Deps with <!nodoc>
  * Added README.Debian explaining the current absence of openmpi and static
    library support, and offering to work on it if someone can help with
    testing
  * Fixed Vcs-* headers to point to where code is packaged
  * Only ship the filter plugin, skip the static library for now (see
    README.Debian)

 -- Enrico Zini <enrico@debian.org>  Sun, 04 Dec 2022 10:45:44 +0100

h5z-zfp (1.1.0+git20221021-1) unstable; urgency=medium

  * Initial version. Closes: #1024358

 -- Enrico Zini <enrico@debian.org>  Tue, 22 Nov 2022 13:20:07 +0100
