=== debian/control ===
Source: h5z-zfp
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Freexian Packaging Team <team+freexian@tracker.debian.org>
Build-Depends:
  architecture-is-little-endian,
  debhelper-compat (= 13), dh-fortran-mod (>= 0.11),
  pkg-config,
  libhdf5-dev, libhdf5-mpi-dev, mpi-default-dev,
  libzfp-dev, hdf5-tools,
  gfortran,
  dh-sequence-sphinxdoc <!nodoc>, python3-sphinx <!nodoc>
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/LLNL/H5Z-ZFP
Vcs-Git: https://salsa.debian.org/science-team/h5z-zfp.git
Vcs-Browser: https://salsa.debian.org/science-team/h5z-zfp

Package: hdf5-filter-plugin-zfp-serial
Provides: hdf5-plugin-zfp
Conflicts: hdf5-plugin-zfp
Replaces: hdf5-plugin-zfp
# h5z-zfp currently fails on big-endian machines. See: https://github.com/LLNL/H5Z-ZFP/issues/95
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${sphinxdoc:Depends}
Description: Compression plugin for the HDF5 library using ZFP compression
 H5Z-ZFP is a compression filter for HDF5 using the ZFP compression library,
 supporting lossy and lossless compression of floating point and integer data
 to meet bitrate, accuracy, and/or precision targets.
