=== debian/watch ===
version=4 opts="searchmode=plain, \
filenamemangle=s/.+/v@ANY_VERSION@/@package@-$1.tar.gz/, \
dversionmangle=auto" \
https://api.github.com/repos/LLNL/H5Z-ZFP/releases \
https://api.github.com/repos/LLNL/H5Z-ZFP/tarball/v@ANY_VERSION@ \
debian uupdate
